
#include <Parameter.h>
#include <Arduino.h>
#include <Audio.h>
#include <Math.h>

float ADC_Input::readParameter(bool a,bool b, bool c)
{
  //set control bit
  uint8_t controlReg = 0x50;
  controlReg = controlReg >> 5;

  //set multiplexer
  uint8_t setHighA = LOW;
  uint8_t setHighB = LOW;
  uint8_t setHighC = LOW;
  if (a == 1) setHighA = HIGH;
  if (b == 1) setHighB = HIGH;
  if (c == 1) setHighC = HIGH;

  //begin adc transmition
  digitalWrite(33,LOW);
  //set multiplexer output
  digitalWrite(multiA,setHighA);
  digitalWrite(multiB,setHighB);
  digitalWrite(multiC,setHighC);
  digitalWrite(adcSelect,LOW);
  //get SPI data
  SPI.beginTransaction(SPISETTING);
  SPI.transfer(controlReg);
  adcValue = SPI.transfer16(0);
  SPI.endTransaction();
  digitalWrite(adcSelect,HIGH);
  //send data to smooth function
  adcAverage = smoothParameter(adcValue);
  digitalWrite(multiA,LOW);
  digitalWrite(multiB,LOW);
  digitalWrite(multiC,LOW);
  digitalWrite(33,HIGH);
  return adcAverage;
}

// Based on Noise reduction smoothing by Damien Clarke.
// http://damienclarke.me/code/posts/writing-a-better-noise-reducing-analogread

float ADC_Input::smoothParameter(float input)
{
  // get difference between last two values
  float difference = abs(input-smoothValue);

  //smoothing depending on amount of input change
  float snap = curve(difference * MULTIPLIER);

  // calculate new value
  smoothValue += (input - smoothValue) * snap;

  return smoothValue;
}

float ADC_Input::curve(float x)
{
  float y = 1 / (x + 1);
  y = (1 - y)*2;
  if (y > 1)
  {
    return 1;
  }
  return y;
}
