
#include <SequencerGen.h>

void Sequencer::stepIncrement(void)
{
  //increment current step
  counterValue++;

  //check if step is off
  if(counterValue % noOfSteps == 0)
  {
   counterValue -= noOfSteps;
   barCount++;
   if(barCount >= 4)
   {
    fillSteps();
    fillNotes();
     barCount = 0;
   }
   //fillNotes();
  }
  //check if step is on, if yes trigger note
  if(steps[counterValue-1] == 1)
  {
    triggerNoteOn(noteFrequency[counterValue-1],noteLenth[counterValue-1]);
  }
  else if(steps[counterValue-1] == 0)
   {
     isNoteOn = false;
   }
}

void Sequencer::timerCheck(void)
{
  if(timer.check() == 1) timerCounter++;
  if ( ((timeOn + currentNoteLength) == timerCounter) && isNoteOn == true)
  {
    triggerNoteOff();
  }
}

void Sequencer::fillSteps(void)
{
  int i;
  randomSeed(seedValue);

  for (i = 0; i < noOfSteps; ++i)
  {
    ran = random(2);
    steps[i] = (uint8_t)ran;
  }
}

void Sequencer::fillNotes(void)
{
  int i;
  randomSeed(seedValue);

  for (i = 0; i < noOfSteps; ++i)
  {

    //generate random values
    randomFrequency = random(1,96);
    randomLength = random(10,120);

    // if step is on apply values to step
    if (steps[i] == 1)
    {
      noteFrequency[i] = randomFrequency;
      noteLenth[i] = (uint16_t)randomLength;
    } else if (steps[i] == 0)
    {
      noteFrequency[i] = 0;
      noteLenth[i] = 0;
    }
  }
}

float Sequencer::outputNoteFrequency(void)
{
  return currentNoteFrequency;
}

void Sequencer::triggerNoteOn(float freq, uint16_t length)
{
  currentNoteLength = length;
  currentNoteFrequency = freq;
  timeOn = timerCounter;
  noteOnFlag = true;
  isNoteOn = true;
  noteOffFlag = false;
}

void Sequencer::triggerNoteOff(void)
{
  noteOffFlag = true;
  isNoteOn = false;
  noteOnFlag = false;

}

bool Sequencer::isNoteOnFlag(void)
{
  return noteOnFlag;
}

bool Sequencer::isNoteOffFlag(void)
{
  return noteOffFlag;
}

void Sequencer::applySeed(int input)
{
  seedValue = input;
}
