

#include <Arduino.h>
#include <Metro.h>
#include <memory>

class Sequencer
{
public:

  Metro timer = Metro(1);
  uint8_t noOfSteps;
  uint8_t * steps;
  uint16_t * noteFrequency;
  uint16_t * noteLenth;
  float * noteVelocity;

  uint16_t currentNoteLength;
  float currentNoteFrequency;
  long ran;
  long randomFrequency;
  long randomLength;
  long randomVelocity;

  time_t time;
  int seedValue = 0;

  Sequencer(uint8_t stepSize) : noOfSteps(stepSize)
  {
  //  std::unique_ptr<uint8_t[]> steps(new uint8_t(stepSize));
    steps = new uint8_t[stepSize];
    noteFrequency = new uint16_t[stepSize];
    noteLenth = new uint16_t[stepSize];
    noteVelocity = new float[stepSize];
    isNoteOn = false;
    currentNoteLength = 50;
    noOfSteps = stepSize;
  }

 ~Sequencer()
  {
    delete[] steps;
    delete[] noteFrequency;
    delete[] noteLenth;
    delete[] noteVelocity;
  }

  void stepIncrement(void);
  void timerCheck(void);
  bool isNoteOnFlag(void);
  bool isNoteOffFlag(void);
  void applySeed(int input);
  void fillSteps(void);
  void fillNotes(void);
  float outputNoteFrequency(void);

private:

    int counterValue = 0;
    int barCount = 0;
    int timerCounter;
    int timeOn;
    bool isNoteOn;
    bool isNoteOff;
    bool noteOnFlag;
    bool noteOffFlag;

    void triggerNoteOn(float freq, uint16_t length);
    void triggerNoteOff(void);
};
