
#include <Arduino.h>
#include <Audio.h>
#include <Wire.h>
#include <SerialFlash.h>
#include <Bounce.h>
#include <ADC.h>
#include <Parameter.h>
#include <SequencerGen.h>
#include <TimerOne.h>
#include <noteFreqDatabase.h>
#include <MIDI.h>

#define MAX_VOICES 8

ADC_Input op1_freq;
ADC_Input op1_level;
ADC_Input op2_freq;
ADC_Input op2_level;
ADC_Input op3_freq;
ADC_Input op3_level;

MIDI_CREATE_INSTANCE(HardwareSerial,Serial1,MIDI);

//AudioInputAnalogStereo op12ModIn(A4,A5);

//op1 voices
AudioSynthWaveformModulated op1Sinev1;
AudioSynthWaveformModulated op1Sinev2;
AudioSynthWaveformModulated op1Sinev3;
AudioSynthWaveformModulated op1Sinev4;
AudioSynthWaveformModulated op1Sinev5;
AudioSynthWaveformModulated op1Sinev6;
AudioSynthWaveformModulated op1Sinev7;
AudioSynthWaveformModulated op1Sinev8;
//op2 voices
AudioSynthWaveformModulated op2Sinev1;
AudioSynthWaveformModulated op2Sinev2;
AudioSynthWaveformModulated op2Sinev3;
AudioSynthWaveformModulated op2Sinev4;
AudioSynthWaveformModulated op2Sinev5;
AudioSynthWaveformModulated op2Sinev6;
AudioSynthWaveformModulated op2Sinev7;
AudioSynthWaveformModulated op2Sinev8;
//op3 voices
AudioSynthWaveformModulated op3Sinev1;
AudioSynthWaveformModulated op3Sinev2;
AudioSynthWaveformModulated op3Sinev3;
AudioSynthWaveformModulated op3Sinev4;
AudioSynthWaveformModulated op3Sinev5;
AudioSynthWaveformModulated op3Sinev6;
AudioSynthWaveformModulated op3Sinev7;
AudioSynthWaveformModulated op3Sinev8;
//op4 voices
AudioSynthWaveformModulated op4Sinev1;
AudioSynthWaveformModulated op4Sinev2;
AudioSynthWaveformModulated op4Sinev3;
AudioSynthWaveformModulated op4Sinev4;
AudioSynthWaveformModulated op4Sinev5;
AudioSynthWaveformModulated op4Sinev6;
AudioSynthWaveformModulated op4Sinev7;
AudioSynthWaveformModulated op4Sinev8;


AudioMixer4 op1Mixer;
AudioMixer4 op1Mixer2;
AudioMixer4 op2Mixer;
AudioMixer4 op2Mixer2;
AudioMixer4 op3Mixer;
AudioMixer4 op3Mixer2;
AudioMixer4 op4Mixer;
AudioMixer4 op4Mixer2;
AudioMixer4 op1MainMixer;
AudioMixer4 op2MainMixer;
AudioMixer4 op3MainMixer;
AudioMixer4 op4MainMixer;
AudioMixer4 mainMixer;

AudioEffectEnvelope op1Env;
AudioEffectEnvelope op1EnvV2;
AudioEffectEnvelope op1EnvV3;
AudioEffectEnvelope op1EnvV4;
AudioEffectEnvelope op1EnvV5;
AudioEffectEnvelope op1EnvV6;
AudioEffectEnvelope op1EnvV7;
AudioEffectEnvelope op1EnvV8;

AudioEffectEnvelope op2Env;
AudioEffectEnvelope op2EnvV2;
AudioEffectEnvelope op2EnvV3;
AudioEffectEnvelope op2EnvV4;
AudioEffectEnvelope op2EnvV5;
AudioEffectEnvelope op2EnvV6;
AudioEffectEnvelope op2EnvV7;
AudioEffectEnvelope op2EnvV8;

AudioEffectEnvelope op3Env;
AudioEffectEnvelope op3EnvV2;
AudioEffectEnvelope op3EnvV3;
AudioEffectEnvelope op3EnvV4;
AudioEffectEnvelope op3EnvV5;
AudioEffectEnvelope op3EnvV6;
AudioEffectEnvelope op3EnvV7;
AudioEffectEnvelope op3EnvV8;

AudioEffectEnvelope op4Env;
AudioEffectEnvelope op4EnvV2;
AudioEffectEnvelope op4EnvV3;
AudioEffectEnvelope op4EnvV4;
AudioEffectEnvelope op4EnvV5;
AudioEffectEnvelope op4EnvV6;
AudioEffectEnvelope op4EnvV7;
AudioEffectEnvelope op4EnvV8;

AudioOutputI2S  i2sOutput;
AudioInputI2S  i2sInput;
AudioOutputAnalogStereo  dac1;

//operator source

AudioConnection sineIn (i2sInput,0, op1Sinev1,0);
AudioConnection sineIn2 (i2sInput,0, op1Sinev2,0);
AudioConnection sineIn3 (i2sInput,0, op1Sinev3,0);
AudioConnection sineIn4 (i2sInput,0, op1Sinev4,0);
// AudioConnection sineIn (i2sInput,0, op1Sinev5,0);
// AudioConnection sineIn2 (i2sInput,0, op1Sinev6,0);
// AudioConnection sineIn3 (i2sInput,0, op1Sinev7,0);
// AudioConnection sineIn4 (i2sInput,0, op1Sinev8,0);
// //
// AudioConnection sine2In (i2sInput,1, op2Sinev1,0);
// AudioConnection sine2In2 (i2sInput,1, op2Sinev2,0);
// AudioConnection sine2In3 (i2sInput,1, op2Sinev3,0);
// AudioConnection sine2In4 (i2sInput,1, op2Sinev4,0);
// AudioConnection sine2In (i2sInput,1, op2Sinev5,0);
// AudioConnection sine2In2 (i2sInput,1, op2Sinev6,0);
// AudioConnection sine2In3 (i2sInput,1, op2Sinev7,0);
// AudioConnection sine2In4 (i2sInput,1, op2Sinev8,0);
//
// AudioConnection sine3In (i2sInput,2, op3Sinev1,0);
// AudioConnection sine3In2 (i2sInput,2, op3Sinev2,0);
// AudioConnection sine3In3 (i2sInput,2, op3Sinev3,0);
// AudioConnection sine3In4 (i2sInput,2, op3Sinev4,0);
// AudioConnection sine3In (i2sInput,2, op3Sinev5,0);
// AudioConnection sine3In2 (i2sInput,2, op3Sinev6,0);
// AudioConnection sine3In3 (i2sInput,2, op3Sinev7,0);
// AudioConnection sine3In4 (i2sInput,2, op3Sinev8,0);
//
// AudioConnection sine4In (i2sInput,3, op4Sinev1,0);
// AudioConnection sine4In2 (i2sInput,3, op4Sinev2,0);
// AudioConnection sine4In3 (i2sInput,3, op4Sinev3,0);
// AudioConnection sine4In4 (i2sInput,3, op4Sinev4,0);
// AudioConnection sine4In (i2sInput,3, op4Sinev5,0);
// AudioConnection sine4In2 (i2sInput,3, op4Sinev6,0);
// AudioConnection sine4In3 (i2sInput,3, op4Sinev7,0);
// AudioConnection sine4In4 (i2sInput,3, op4Sinev8,0);

//operator envelope
AudioConnection op1v1(op1Sinev1,0,op1Env,0);
AudioConnection op1v2(op1Sinev2,0,op1EnvV2,0);
AudioConnection op1v3(op1Sinev3,0,op1EnvV3,0);
AudioConnection op1v4(op1Sinev4,0,op1EnvV4,0);
AudioConnection op1v5(op1Sinev5,0,op1EnvV5,0);
AudioConnection op1v6(op1Sinev6,0,op1EnvV6,0);
AudioConnection op1v7(op1Sinev7,0,op1EnvV7,0);
AudioConnection op1v8(op1Sinev8,0,op1EnvV8,0);

AudioConnection op2v1(op2Sinev1,0,op2Env,0);
AudioConnection op2v2(op2Sinev2,0,op2EnvV2,0);
AudioConnection op2v3(op2Sinev3,0,op2EnvV3,0);
AudioConnection op2v4(op2Sinev4,0,op2EnvV4,0);
AudioConnection op2v5(op2Sinev5,0,op2EnvV5,0);
AudioConnection op2v6(op2Sinev6,0,op2EnvV6,0);
AudioConnection op2v7(op2Sinev7,0,op2EnvV7,0);
AudioConnection op2v8(op2Sinev8,0,op2EnvV8,0);

AudioConnection op3v1(op3Sinev1,0,op3Env,0);
AudioConnection op3v2(op3Sinev2,0,op3EnvV2,0);
AudioConnection op3v3(op3Sinev3,0,op3EnvV3,0);
AudioConnection op3v4(op3Sinev4,0,op3EnvV4,0);
AudioConnection op3v5(op3Sinev5,0,op3EnvV5,0);
AudioConnection op3v6(op3Sinev6,0,op3EnvV6,0);
AudioConnection op3v7(op3Sinev7,0,op3EnvV7,0);
AudioConnection op3v8(op3Sinev8,0,op3EnvV8,0);

AudioConnection op4v1(op4Sinev1,0,op4Env,0);
AudioConnection op4v2(op4Sinev2,0,op4EnvV2,0);
AudioConnection op4v3(op4Sinev3,0,op4EnvV3,0);
AudioConnection op4v4(op4Sinev4,0,op4EnvV4,0);
AudioConnection op4v5(op4Sinev5,0,op4EnvV5,0);
AudioConnection op4v6(op4Sinev6,0,op4EnvV6,0);
AudioConnection op4v7(op4Sinev7,0,op4EnvV7,0);
AudioConnection op4v8(op4Sinev8,0,op4EnvV8,0);

//operator mixers

AudioConnection op1v1mixer(op1Env,0,op1Mixer,0);
AudioConnection op1v2mixer(op1EnvV2,0,op1Mixer,1);
AudioConnection op1v3mixer(op1EnvV3,0,op1Mixer,2);
AudioConnection op1v4mixer(op1EnvV4,0,op1Mixer,3);
AudioConnection op1v5mixer(op1EnvV5,0,op1Mixer2,0);
AudioConnection op1v6mixer(op1EnvV6,0,op1Mixer2,1);
AudioConnection op1v7mixer(op1EnvV7,0,op1Mixer2,2);
AudioConnection op1v8mixer(op1EnvV8,0,op1Mixer2,3);

AudioConnection op2v1mixer(op2Env,0,op2Mixer,0);
AudioConnection op2v2mixer(op2EnvV2,0,op2Mixer,1);
AudioConnection op2v3mixer(op2EnvV3,0,op2Mixer,2);
AudioConnection op2v4mixer(op2EnvV4,0,op2Mixer,3);
AudioConnection op2v5mixer(op2EnvV5,0,op2Mixer2,0);
AudioConnection op2v6mixer(op2EnvV6,0,op2Mixer2,1);
AudioConnection op2v7mixer(op2EnvV7,0,op2Mixer2,2);
AudioConnection op2v8mixer(op2EnvV8,0,op2Mixer2,3);

AudioConnection op3v1mixer(op3Env,0,op3Mixer,0);
AudioConnection op3v2mixer(op3EnvV2,0,op3Mixer,1);
AudioConnection op3v3mixer(op3EnvV3,0,op3Mixer,2);
AudioConnection op3v4mixer(op3EnvV4,0,op3Mixer,3);
AudioConnection op3v5mixer(op3EnvV5,0,op3Mixer2,0);
AudioConnection op3v6mixer(op3EnvV6,0,op3Mixer2,1);
AudioConnection op3v7mixer(op3EnvV7,0,op3Mixer2,2);
AudioConnection op3v8mixer(op3EnvV8,0,op3Mixer2,3);

AudioConnection op4v1mixer(op4Env,0,op4Mixer,0);
AudioConnection op4v2mixer(op4EnvV2,0,op4Mixer,1);
AudioConnection op4v3mixer(op4EnvV3,0,op4Mixer,2);
AudioConnection op4v4mixer(op4EnvV4,0,op4Mixer,3);
AudioConnection op4v5mixer(op4EnvV5,0,op4Mixer2,0);
AudioConnection op4v6mixer(op4EnvV6,0,op4Mixer2,1);
AudioConnection op4v7mixer(op4EnvV7,0,op4Mixer2,2);
AudioConnection op4v8mixer(op4EnvV8,0,op4Mixer2,3);


AudioConnection op1MainMixer1(op1Mixer,0,op1MainMixer,0);
AudioConnection op1MainMixer2(op1Mixer2,0,op1MainMixer,1);

AudioConnection op2MainMixer1(op2Mixer,0,op2MainMixer,0);
AudioConnection op2MainMixer2(op2Mixer2,0,op2MainMixer,1);

AudioConnection op3MainMixer1(op3Mixer,0,op3MainMixer,0);
AudioConnection op3MainMixer2(op3Mixer2,0,op3MainMixer,1);

AudioConnection op4MainMixer1(op4Mixer,0,op4MainMixer,0);
AudioConnection op4MainMixer2(op4Mixer2,0,op4MainMixer,1);

// mixer main

AudioConnection op1Mix(op1MainMixer,0,mainMixer,0);
AudioConnection op2Mix(op2MainMixer,0,mainMixer,1);
AudioConnection op3Mix(op3MainMixer,0,mainMixer,2);
AudioConnection op4Mix(op4MainMixer,0,mainMixer,2);

// AudioConnection op2Modout(op2Env,0,i2sOutput,2);
// AudioConnection op3Modout(op3Env,0,i2sOutput,3);

// AudioConnection op2Modouttest(op2Env,0,dac1,0);
// AudioConnection op3Modouttest(op3Env,0,dac1,1);

AudioConnection mainout(mainMixer,0,i2sOutput,0);
AudioConnection op4Modout(op3Env,0,i2sOutput,1);

Sequencer sequencer1(16);
NoteFrequencyTable operatorNote;
//AudioSPI_Transfer testTransfer;

const int readPin = A16;
const int envTrig = 26;
const int OP2out = 35;
const int OP3out = 36;
bool oscSync = true;
bool isOP2Modulator = true;
bool isOP3Modulator = true;

float maxModulatorFreq = 200.0f;
float maxCarrierFreq = 11000.0f;
int maxOP1Freq;
int maxOP2Freq;
int maxOP3Freq;

bool noteFlag = false;
bool isNoteOn = false;
bool isNoteOff = false;
bool noteOFFlag = false;
bool sequencerOn = false;
volatile int counter1 = 0;
volatile int timerCounter = 0;
int seedValue;

float op1Attack = 0.5f;
float op1Decay = 200.0f;
float op1Sustain = 0.5f;
float op1Release = 60.0f;
float op2Attack = 0.5f;
float op2Decay = 200.0f;
float op2Sustain = 0.5f;
float op2Release = 60.0f;
float op3Attack = 0.5f;
float op3Decay = 200.0f;
float op3Sustain = 0.5f;
float op3Release = 60.0f;
float op4Attack = 0.5f;
float op4Decay = 200.0f;
float op4Sustain = 0.5f;
float op4Release = 60.0f;

float op1frequency[MAX_VOICES];
float op2frequency[MAX_VOICES];
float op3frequency[MAX_VOICES];
float op4frequency[MAX_VOICES];
float op1level;
float op2level;
float op3level;
float op4level;
int8_t op1CurrentNote[MAX_VOICES];
int8_t op2CurrentNote[MAX_VOICES];
int8_t op3CurrentNote[MAX_VOICES];
int8_t op4CurrentNote[MAX_VOICES];
int8_t notes[MAX_VOICES] = {-1,-1,-1,-1,-1,-1,-1,-1};
bool isVoiceOn[MAX_VOICES] = {false,false,false,false,false,false,false,false};
bool isVoiceOff[MAX_VOICES] = {false,false,false,false,false,false,false,false};
bool voiceOnFlag[MAX_VOICES] = {false,false,false,false,false,false,false,false};
bool voiceOffFlag[MAX_VOICES] = {false,false,false,false,false,false,false,false};
uint8_t voicePosition = 0;

IntervalTimer clockTimer;
int type, note, velocity, channel, d1, d2;

float scaleToRange(float inputData, float maxIn, float minIn, float maxOut, float minOut)
{
  return (((maxOut - minOut) * (inputData - minIn)) / (maxIn - minIn)) + minOut;
}

void addVoice(int8_t note)
{
  if (notes[voicePosition] == -1) notes[voicePosition] = note;
  voicePosition++;
  while (voicePosition > MAX_VOICES-1) voicePosition = 0;
}

void removeVoice(int8_t note)
{
  for (int i = 0; i < MAX_VOICES; ++i)
  {
    if (notes[i] == note)
    {
      notes[i] = -1;
      voicePosition--;
      while (voicePosition < 0) voicePosition = 0;
    }
  }
}

void resetVoices(void)
{
  for (int i = 0; i < MAX_VOICES; ++i)
  {
    if (notes[i] != 1 && isVoiceOff[i]) notes[i] = -1;
  }
  //voicePosition = 0;
}

void clock(void)
{
  //increment sequencer step
  sequencer1.stepIncrement();
  sequencer1.applySeed(seedValue);

  //trigger envelope if step is on
  if(sequencer1.isNoteOnFlag() && !isNoteOn && sequencerOn)
  {
    op1Env.noteOn();
    op2Env.noteOn();
    op3Env.noteOn();
    isNoteOn = true;
    isNoteOff = false;
  }
}

void setup()
 {
    AudioMemory(100);
    Serial1.setRX(0);
    MIDI.begin(MIDI_CHANNEL_OMNI);
    Serial.begin(9600);
    //get current adc value to act as seed for RNG
    seedValue = scaleToRange( op1_freq.readParameter(0,0,0),5000,200,20,20000);
    sequencer1.applySeed(seedValue);
    //setup sequencer
    sequencer1.fillSteps();
    sequencer1.fillNotes();
    //start clock
    clockTimer.begin(clock,100000);

    op1Sinev1.begin(WAVEFORM_SAWTOOTH);
    op1Sinev2.begin(WAVEFORM_SAWTOOTH);
    op1Sinev3.begin(WAVEFORM_SAWTOOTH);
    op1Sinev4.begin(WAVEFORM_SAWTOOTH);
    op1Sinev5.begin(WAVEFORM_SAWTOOTH);
    op1Sinev6.begin(WAVEFORM_SAWTOOTH);
    op1Sinev7.begin(WAVEFORM_SAWTOOTH);
    op1Sinev8.begin(WAVEFORM_SAWTOOTH);
    //op1Sinev1.frequencyModulation(1);

    //pinMode(13,OUTPUT);
    pinMode(OP2out,INPUT);
    pinMode(OP3out,INPUT);
    //digitalWrite(13,HIGH);
}

void loop()
 {

 if (MIDI.read()) {                    // Is there a MIDI message incoming ?
   byte type = MIDI.getType();
   switch (type) {
     case midi::NoteOn:
       note = MIDI.getData1();
       velocity = MIDI.getData2();
       channel = MIDI.getChannel();
      if(note <= 96 && note >= 0)
      {
       addVoice(note);

       if (velocity > 0) {
         if(notes[0] != -1 && !isVoiceOn[0])
         {
             op1Env.noteOn();
             op2Env.noteOn();
             op3Env.noteOn();
             isVoiceOn[0] = true;
             isVoiceOff[0] = false;
         }

         else if(notes[1] != -1 && !isVoiceOn[1])
         {
             op1EnvV2.noteOn();
             op2EnvV2.noteOn();
             op3EnvV2.noteOn();
             isVoiceOn[1] = true;
             isVoiceOff[1] = false;
         }

         else if(notes[2] != -1 && !isVoiceOn[2])
         {
             op1EnvV3.noteOn();
             op2EnvV3.noteOn();
             op3EnvV3.noteOn();
             isVoiceOn[2] = true;
             isVoiceOff[2] = false;
         }

         else if(notes[3] != -1 && !isVoiceOn[3])
         {
             op1EnvV4.noteOn();
             op2EnvV4.noteOn();
             op3EnvV4.noteOn();
             isVoiceOn[3] = true;
             isVoiceOff[3] = false;
          }

          else if(notes[4] != -1 && !isVoiceOn[4])
          {
              op1EnvV5.noteOn();
              op2EnvV5.noteOn();
              op3EnvV5.noteOn();
              isVoiceOn[4] = true;
              isVoiceOff[4] = false;
          }

          else if(notes[5] != -1 && !isVoiceOn[5])
          {
              op1EnvV6.noteOn();
              op2EnvV6.noteOn();
              op3EnvV6.noteOn();
              isVoiceOn[5] = true;
              isVoiceOff[5] = false;
          }

          else if(notes[6] != -1 && !isVoiceOn[6])
          {
              op1EnvV7.noteOn();
              op2EnvV7.noteOn();
              op3EnvV7.noteOn();
              isVoiceOn[6] = true;
              isVoiceOff[6] = false;
          }

          else if(notes[7] != -1 && !isVoiceOn[7])
          {
              op1EnvV8.noteOn();
              op2EnvV8.noteOn();
              op3EnvV8.noteOn();
              isVoiceOn[7] = true;
              isVoiceOff[7] = false;
           }

       }

       }
       break;
     case midi::NoteOff:
       note = MIDI.getData1();
       velocity = MIDI.getData2();
       channel = MIDI.getChannel();
       removeVoice(note);

        if(notes[0] == -1 && !isVoiceOff[0])
        {
             op1Env.noteOff();
             op2Env.noteOff();
             op3Env.noteOff();
             isVoiceOn[0] = false;
             isVoiceOff[0] = true;
        }

        else if(notes[1] == -1 && !isVoiceOff[1])
        {
             op1EnvV2.noteOff();
             op2EnvV2.noteOff();
             op3EnvV2.noteOff();
             isVoiceOn[1] = false;
             isVoiceOff[1] = true;
        }

        else if(notes[2] == -1 && !isVoiceOff[2])
        {
             op1EnvV3.noteOff();
             op2EnvV3.noteOff();
             op3EnvV3.noteOff();
             isVoiceOn[2] = false;
             isVoiceOff[2] = true;
        }

        else if(notes[3] == -1 && !isVoiceOff[3])
        {
             op1EnvV4.noteOff();
             op2EnvV4.noteOff();
             op3EnvV4.noteOff();
             isVoiceOn[3] = false;
             isVoiceOff[3] = true;
        }

        else if(notes[4] == -1 && !isVoiceOff[4])
        {
             op1EnvV5.noteOff();
             op2EnvV5.noteOff();
             op3EnvV5.noteOff();
             isVoiceOn[4] = false;
             isVoiceOff[4] = true;
        }

        else if(notes[5] == -1 && !isVoiceOff[5])
        {
             op1EnvV6.noteOff();
             op2EnvV6.noteOff();
             op3EnvV6.noteOff();
             isVoiceOn[5] = false;
             isVoiceOff[5] = true;
        }

        else if(notes[6] == -1 && !isVoiceOff[6])
        {
             op1EnvV7.noteOff();
             op2EnvV7.noteOff();
             op3EnvV7.noteOff();
             isVoiceOn[6] = false;
             isVoiceOff[6] = true;
        }

        else if(notes[7] == -1 && !isVoiceOff[7])
        {
             op1EnvV8.noteOff();
             op2EnvV8.noteOff();
             op3EnvV8.noteOff();
             isVoiceOn[7] = false;
             isVoiceOff[7] = true;
        }

       break;
     default:
       d1 = MIDI.getData1();
       d2 = MIDI.getData2();
   }
 }
 resetVoices();

    // operator 2 check
   if(digitalRead(OP2out))isOP2Modulator = true;
   else if(!digitalRead(OP2out))isOP2Modulator = false;

    if(isOP2Modulator)
    {
      maxOP2Freq = maxModulatorFreq;
      mainMixer.gain(1,0.0);
    }

    else if(!isOP2Modulator)
    {
      maxOP2Freq = maxCarrierFreq;
      mainMixer.gain(1,0.7);
    }
    // operator 3 check
    if(digitalRead(OP3out)) isOP3Modulator = true;
    else if(!digitalRead(OP3out)) isOP3Modulator = false;

    if(isOP3Modulator)
    {
      maxOP3Freq = maxModulatorFreq;
      mainMixer.gain(2,0);
    }

    else if(!isOP3Modulator)
    {
      maxOP3Freq = maxCarrierFreq;
      mainMixer.gain(2,0.7);
    }


    seedValue = scaleToRange( op1_freq.readParameter(0,0,0),5000,200,20,20000);
    //apply frequency and level to each operator using ADC_Input

    op1level = scaleToRange( op1_level.readParameter(1,1,0),5000,200,0,0.7);
    op2level = scaleToRange( op2_level.readParameter(0,0,1),5000,200,0,0.7);
    op3level = scaleToRange( op3_level.readParameter(1,0,1),5000,200,0,0.7);

    sequencer1.timerCheck();

    if(sequencer1.isNoteOffFlag() && !isNoteOff && sequencerOn)
    {
       op1Env.noteOff();
       op2Env.noteOff();
       op3Env.noteOff();
       isNoteOff = true;
       isNoteOn = false;
    }

    for (int i = 0; i < MAX_VOICES; ++i)
    {

      if (!sequencerOn)
      {
        op1CurrentNote[i] = notes[i];
        op2CurrentNote[i] = notes[i];
        op3CurrentNote[i] = notes[i];
      }

      else if (sequencerOn)
      {
        op1CurrentNote[i] = sequencer1.outputNoteFrequency();
        op2CurrentNote[i] = sequencer1.outputNoteFrequency();
        op3CurrentNote[i] = sequencer1.outputNoteFrequency();
      }

      op1CurrentNote[i] += scaleToRange( op1_freq.readParameter(0,0,0),5000,205,-48,48);
      op2CurrentNote[i] += scaleToRange( op2_freq.readParameter(1,0,0),5000,205,-48,48);
      op3CurrentNote[i] += scaleToRange( op3_freq.readParameter(0,1,0),5000,205,-48,48);

      if (op1CurrentNote[i] >= 96) op1CurrentNote[i] = 96;
      if (op1CurrentNote[i] <= 0) op1CurrentNote[i] = 0;

      op1frequency[i] = operatorNote.getFrequency(op1CurrentNote[i]);
      op2frequency[i] = operatorNote.getFrequency(op2CurrentNote[i]);
      op3frequency[i] = operatorNote.getFrequency(op3CurrentNote[i]);

    }

    op1Sinev1.frequency(op1frequency[0]);
    op1Sinev2.frequency(op1frequency[1]);
    op1Sinev3.frequency(op1frequency[2]);
    op1Sinev4.frequency(op1frequency[3]);
    op1Sinev5.frequency(op1frequency[4]);
    op1Sinev6.frequency(op1frequency[5]);
    op1Sinev7.frequency(op1frequency[6]);
    op1Sinev8.frequency(op1frequency[7]);

    op2Sinev1.frequency(op2frequency[0]);
    op2Sinev2.frequency(op2frequency[1]);
    op2Sinev3.frequency(op2frequency[2]);
    op2Sinev4.frequency(op2frequency[3]);
    op2Sinev5.frequency(op2frequency[4]);
    op2Sinev6.frequency(op2frequency[5]);
    op2Sinev7.frequency(op2frequency[6]);
    op2Sinev8.frequency(op2frequency[7]);

    op3Sinev1.frequency(op3frequency[0]);
    op3Sinev2.frequency(op3frequency[1]);
    op3Sinev3.frequency(op3frequency[2]);
    op3Sinev4.frequency(op3frequency[3]);
    op3Sinev5.frequency(op3frequency[4]);
    op3Sinev6.frequency(op3frequency[5]);
    op3Sinev7.frequency(op3frequency[6]);
    op3Sinev8.frequency(op3frequency[7]);

    op1Sinev1.amplitude(op1level);
    op1Sinev2.amplitude(op1level);
    op1Sinev3.amplitude(op1level);
    op1Sinev4.amplitude(op1level);
    op1Sinev5.amplitude(op1level);
    op1Sinev6.amplitude(op1level);
    op1Sinev7.amplitude(op1level);
    op1Sinev8.amplitude(op1level);

    op2Sinev1.amplitude(op2level);
    op2Sinev2.amplitude(op2level);
    op2Sinev3.amplitude(op2level);
    op2Sinev4.amplitude(op2level);
    op2Sinev5.amplitude(op2level);
    op2Sinev6.amplitude(op2level);
    op2Sinev7.amplitude(op2level);
    op2Sinev8.amplitude(op2level);

    op3Sinev1.amplitude(op3level);
    op3Sinev2.amplitude(op3level);
    op3Sinev3.amplitude(op3level);
    op3Sinev4.amplitude(op3level);
    op3Sinev5.amplitude(op3level);
    op3Sinev6.amplitude(op3level);
    op3Sinev7.amplitude(op3level);
    op3Sinev8.amplitude(op3level);

    op1Mixer.gain(0,0.95);
    op1Mixer.gain(1,0.95);
    op1Mixer.gain(2,0.95);
    op1Mixer.gain(3,0.95);
    op1Mixer2.gain(0,0.95);
    op1Mixer2.gain(1,0.95);
    op1Mixer2.gain(2,0.95);
    op1Mixer2.gain(3,0.95);

    op2Mixer.gain(0,0.95);
    op2Mixer.gain(1,0.95);
    op2Mixer.gain(2,0.95);
    op2Mixer.gain(3,0.95);
    op2Mixer2.gain(0,0.95);
    op2Mixer2.gain(1,0.95);
    op2Mixer2.gain(2,0.95);
    op2Mixer2.gain(3,0.95);

    op3Mixer.gain(0,0.95);
    op3Mixer.gain(1,0.95);
    op3Mixer.gain(2,0.95);
    op3Mixer.gain(3,0.95);
    op3Mixer2.gain(0,0.95);
    op3Mixer2.gain(1,0.95);
    op3Mixer2.gain(2,0.95);
    op3Mixer2.gain(3,0.95);


    op1MainMixer.gain(0,0.95);
    op1MainMixer.gain(1,0.95);
    op2MainMixer.gain(0,0.95);
    op2MainMixer.gain(1,0.95);
    op3MainMixer.gain(0,0.95);
    op3MainMixer.gain(1,0.95);
    op4MainMixer.gain(0,0.95);
    op4MainMixer.gain(1,0.95);

    op1Env.attack(op1Attack);
    op1Env.decay(op1Decay);
    op1Env.sustain(op1Sustain);
    op1Env.release(op1Release);
    op1Env.delay(0.0);
    op1Env.hold(0.0);
    op1EnvV2.attack(op1Attack);
    op1EnvV2.decay(op1Decay);
    op1EnvV2.sustain(op1Sustain);
    op1EnvV2.release(op1Release);
    op1EnvV2.delay(0.0);
    op1EnvV2.hold(0.0);
    op1EnvV3.attack(op1Attack);
    op1EnvV3.decay(op1Decay);
    op1EnvV3.sustain(op1Sustain);
    op1EnvV3.release(op1Release);
    op1EnvV3.delay(0.0);
    op1EnvV3.hold(0.0);
    op1EnvV4.attack(op1Attack);
    op1EnvV4.decay(op1Decay);
    op1EnvV4.sustain(op1Sustain);
    op1EnvV4.release(op1Release);
    op1EnvV4.delay(0.0);
    op1EnvV4.hold(0.0);

    op2Env.attack(op2Attack);
    op2Env.decay(op2Decay);
    op2Env.sustain(op2Sustain);
    op2Env.release(op2Release);
    op2Env.delay(0.0);
    op2Env.hold(0.0);
    op2EnvV2.attack(op2Attack);
    op2EnvV2.decay(op2Decay);
    op2EnvV2.sustain(op2Sustain);
    op2EnvV2.release(op2Release);
    op2EnvV2.delay(0.0);
    op2EnvV2.hold(0.0);
    op2EnvV3.attack(op2Attack);
    op2EnvV3.decay(op2Decay);
    op2EnvV3.sustain(op2Sustain);
    op2EnvV3.release(op2Release);
    op2EnvV3.delay(0.0);
    op2EnvV3.hold(0.0);
    op2EnvV4.attack(op2Attack);
    op2EnvV4.decay(op2Decay);
    op2EnvV4.sustain(op2Sustain);
    op2EnvV4.release(op2Decay);
    op2EnvV4.delay(0.0);
    op2EnvV4.hold(0.0);

    op3Env.attack(op3Attack);
    op3Env.decay(op3Decay);
    op3Env.sustain(op3Sustain);
    op3Env.release(op4Release);
    op3Env.delay(0.0);
    op3Env.hold(0.0);
    op3EnvV2.attack(op3Attack);
    op3EnvV2.decay(op3Decay);
    op3EnvV2.sustain(op3Sustain);
    op3EnvV2.release(op4Release);
    op3EnvV2.delay(0.0);
    op3EnvV2.hold(0.0);
    op3EnvV3.attack(op3Attack);
    op3EnvV3.decay(op3Decay);
    op3EnvV3.sustain(op3Sustain);
    op3EnvV3.release(op4Release);
    op3EnvV3.delay(0.0);
    op3EnvV3.hold(0.0);
    op3EnvV4.attack(op3Attack);
    op3EnvV4.decay(op3Decay);
    op3EnvV4.sustain(op3Sustain);
    op3EnvV4.release(op4Release);
    op3EnvV4.delay(0.0);
    op3EnvV4.hold(0.0);

    mainMixer.gain(0,0.95);
    mainMixer.gain(1,0.95);
    mainMixer.gain(2,0.95);
    mainMixer.gain(3,0.95);
}
